/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DialogflowEncryptionSpecConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/dialogflow_encryption_spec#id DialogflowEncryptionSpec#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The location in which the encryptionSpec is to be initialized.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/dialogflow_encryption_spec#location DialogflowEncryptionSpec#location}
    */
    readonly location: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/dialogflow_encryption_spec#project DialogflowEncryptionSpec#project}
    */
    readonly project?: string;
    /**
    * encryption_spec block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/dialogflow_encryption_spec#encryption_spec DialogflowEncryptionSpec#encryption_spec}
    */
    readonly encryptionSpec: DialogflowEncryptionSpecEncryptionSpec;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/dialogflow_encryption_spec#timeouts DialogflowEncryptionSpec#timeouts}
    */
    readonly timeouts?: DialogflowEncryptionSpecTimeouts;
}
export interface DialogflowEncryptionSpecEncryptionSpec {
    /**
    * The name of customer-managed encryption key that is used to secure a resource and its sub-resources.
    * If empty, the resource is secured by the default Google encryption key.
    * Only the key in the same location as this resource is allowed to be used for encryption.
    * Format: projects/{project}/locations/{location}/keyRings/{keyRing}/cryptoKeys/{key}
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/dialogflow_encryption_spec#kms_key DialogflowEncryptionSpec#kms_key}
    */
    readonly kmsKey: string;
}
export declare function dialogflowEncryptionSpecEncryptionSpecToTerraform(struct?: DialogflowEncryptionSpecEncryptionSpecOutputReference | DialogflowEncryptionSpecEncryptionSpec): any;
export declare function dialogflowEncryptionSpecEncryptionSpecToHclTerraform(struct?: DialogflowEncryptionSpecEncryptionSpecOutputReference | DialogflowEncryptionSpecEncryptionSpec): any;
export declare class DialogflowEncryptionSpecEncryptionSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DialogflowEncryptionSpecEncryptionSpec | undefined;
    set internalValue(value: DialogflowEncryptionSpecEncryptionSpec | undefined);
    private _kmsKey?;
    get kmsKey(): string;
    set kmsKey(value: string);
    get kmsKeyInput(): string | undefined;
}
export interface DialogflowEncryptionSpecTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/dialogflow_encryption_spec#create DialogflowEncryptionSpec#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/dialogflow_encryption_spec#delete DialogflowEncryptionSpec#delete}
    */
    readonly delete?: string;
}
export declare function dialogflowEncryptionSpecTimeoutsToTerraform(struct?: DialogflowEncryptionSpecTimeouts | cdktf.IResolvable): any;
export declare function dialogflowEncryptionSpecTimeoutsToHclTerraform(struct?: DialogflowEncryptionSpecTimeouts | cdktf.IResolvable): any;
export declare class DialogflowEncryptionSpecTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DialogflowEncryptionSpecTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: DialogflowEncryptionSpecTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/dialogflow_encryption_spec google_dialogflow_encryption_spec}
*/
export declare class DialogflowEncryptionSpec extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_dialogflow_encryption_spec";
    /**
    * Generates CDKTF code for importing a DialogflowEncryptionSpec resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DialogflowEncryptionSpec to import
    * @param importFromId The id of the existing DialogflowEncryptionSpec that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/dialogflow_encryption_spec#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DialogflowEncryptionSpec to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/dialogflow_encryption_spec google_dialogflow_encryption_spec} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DialogflowEncryptionSpecConfig
    */
    constructor(scope: Construct, id: string, config: DialogflowEncryptionSpecConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    get locationInput(): string | undefined;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _encryptionSpec;
    get encryptionSpec(): DialogflowEncryptionSpecEncryptionSpecOutputReference;
    putEncryptionSpec(value: DialogflowEncryptionSpecEncryptionSpec): void;
    get encryptionSpecInput(): DialogflowEncryptionSpecEncryptionSpec | undefined;
    private _timeouts;
    get timeouts(): DialogflowEncryptionSpecTimeoutsOutputReference;
    putTimeouts(value: DialogflowEncryptionSpecTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | DialogflowEncryptionSpecTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
